/*
 * open interface 
 * 		University Computing Center, SRCE
 * Date:	Fri Jun 14 1996
 * Copyright (c) 1996,  Damir Delija
 * 
 * function snmdb_get_property 
 * snmdb_data snmdb_get_property (snmdb_buffer *, char *, snmdb_type *); 
 * 
 */

#include <stddef.h>
#include <string.h>
#include <stdlib.h>
#include <tcl.h>
#include <netmgt/netmgt_db.h>

#include <handle_t.h>

	
int TcldbTypeParse( typ, rez, result) 
snmdb_type typ;
snmdb_data *rez;
char *result;
{
	switch (typ) {
	case	undefined:
	        if ( typ==undefined ) return TCL_ERROR;
	case	short_integer:
	        sprintf (result, "%d", rez->db_short);
	break;
	case	unsigned_short_integer:
	        sprintf (result, "%d", rez->db_ushort);
	break;
	case	enumeration:
	case	integer:
	        sprintf (result, "%d", rez->db_int);
	break;
	case	unsigned_integer:
	case	counter:
	case	gauge:
	        sprintf (result, "%d", rez->db_uint);
	break;
	case	long_integer:
	        sprintf (result, "%d", rez->db_long);
	break;
	case	unsigned_long_integer:
	case	timeticks:
	case	unixtime:
	        sprintf (result, "%d", rez->db_ulong);
	break;
	case	floating_point:
	        sprintf (result, "%f", rez->db_float);
	break;
	case	double_floating_point:
	        sprintf (result, "%f", rez->db_double);
	break;
	case	octet:
	case	string:
	        sprintf (result, "%s", rez->db_string);
	break;
	case	netaddress:
	case	ipaddress:
	        sprintf (result, "%s", rez->db_address);
	default:
	        sprintf (result, "Unknown type %d", typ);
	}
	
	return TCL_OK;
}

int tclsnmdb_get_property(
	void *clientData,
	Tcl_Interp *interp,
	int argc, 
	char **argv)
{
char *name=NULL;
char *prop=NULL;

extern void_pt bufferHandleTable;

snmdb_data data; 
snmdb_type type=undefined; 
snmdb_buffer *buffer;
void_pt *hdl=NULL;
int rez=TCL_OK;
 
 
	name=argv[1];
	prop=argv[2];
 
        hdl = Tcl_HandleXlate( interp, bufferHandleTable,name);
        if (hdl==NULL || *hdl==NULL) return TCL_ERROR;
        buffer=(snmdb_buffer*) *hdl;

        data=snmdb_get_property(buffer,prop,&type);
	rez=TcldbTypeParse(type,&data,interp->result);

	return rez;
}
