/*
 * open interface 
 * 		University Computing Center, SRCE
 * Date  	Fri Jun 14 1996
 * Copyright (c) 1996,  Damir Delija
 * 
 * function snmdb_get_property 
 * snmdb_data snmdb_get_property (snmdb_buffer *, char *, snmdb_type *); 
 * 
 */

#include <stddef.h>
#include <string.h>
#include <stdlib.h>
#include <netmgt/netmgt_db.h>

int db_type2string( snmdb_type typ, snmdb_data *rez, char *result )
{
	if ( rez==NULL || result==NULL ) return 0;
	switch (typ) {
	case  undefined:
		return 0;

	case  short_integer:
		sprintf (result,"%d",rez->db_int);
	break;
	case  unsigned_short_integer:
		sprintf (result,"%d",rez->db_ushort);
	break;

	case  counter:
	case  gauge:
	case  unsigned_integer:
		sprintf (result,"%d",rez->db_uint);
	break;

	case  long_integer:
		sprintf (result,"%d",rez->db_long);
	break;

	case  unsigned_long_integer:
	case  unixtime:
	case  timeticks:
		sprintf (result,"%d",rez->db_ulong);
	break;

	case  floating_point:
		sprintf (result,"%f",rez->db_float);
	break;

	case  double_floating_point:
		sprintf (result,"%f",rez->db_double);
	break;

	case  octet:
	case  string:
		sprintf (result,"%s",rez->db_string);
	break;

	case  netaddress:
	case  ipaddress:
		sprintf (result,"%s",rez->db_address);
	break;

	case  enumeration:
	case  integer:
		sprintf (result,"%d",rez->db_int);
	break;

	default :
		sprintf (result,"Unknown type %d",typ);
		
	}
	return 1;

}

int val2db_type( snmdb_type typ, char* val,  snmdb_data *rez )
{
	if ( rez==NULL || val==NULL ) return 0;

	switch (typ) {

	case  undefined:
		return 0;

	case  short_integer:
		rez->db_int=(unsigned int) *val;
	break;
	case  unsigned_short_integer:
		rez->db_ushort=(unsigned short) *val;
	break;

	case  counter:
	case  gauge:
	case  unsigned_integer:
		rez->db_uint=(unsigned int)*val;
	break;

	case  long_integer:
		rez->db_long=(long) *val;
	break;

	case  unsigned_long_integer:
	case  unixtime:
	case  timeticks:
		rez->db_ulong=(unsigned long) *val;
	break;

	case  floating_point:
		rez->db_float=(float)*val;
	break;

	case  double_floating_point:
		rez->db_double=(double) *val;
	break;

	case  octet:
	case  string:
		sprintf (rez->db_string,"%s",val);
	break;

	case  netaddress:
	case  ipaddress:
		sprintf (rez->db_address,"%16s",val);
	break;

	case  enumeration:
	case  integer:
		rez->db_int=(int) *val;
	break;
	default :
		return 0;
	}

	return 1;

}

int string2db_type( snmdb_type typ, snmdb_data *rez, char *val )
{
	if ( rez==NULL || val==NULL ) return 0;
	switch (typ) {
	case  undefined:
		return 0;

	case  short_integer:
		sscanf (val,"%d",&rez->db_int);
	break;
	case  unsigned_short_integer:
		sscanf (val,"%d",&rez->db_ushort);
	break;

	case  counter:
	case  gauge:
	case  unsigned_integer:
		sscanf (val,"%d",&rez->db_uint);
	break;

	case  long_integer:
		sscanf (val,"%d",&rez->db_long);
	break;

	case  unsigned_long_integer:
	case  unixtime:
	case  timeticks:
		sscanf (val,"%d",&rez->db_ulong);
	break;

	case  floating_point:
		sscanf (val,"%f",&rez->db_float);
	break;

	case  double_floating_point:
		sscanf (val,"%f",&rez->db_double);
	break;

	case  octet:
	case  string:
		sprintf(rez->db_string,"%s",val);
	break;

	case  netaddress:
	case  ipaddress:
		sprintf(rez->db_address,"%s",val);
	break;

	case  enumeration:
	case  integer:
		sscanf (val,"%d",&rez->db_int);
	break;
		default: return 0;

	}
	return 1;

}
