/*
 * open interface 
 * 		University Computing Center, SRCE
 * Date:	Fri Jun 14 1996
 * Copyright (c) 1996,  Damir Delija
 * 
 * function snmdb_init_buffer 
 * int snmdb_init_buffer (char *, char *, snmdb_buffer *); 
 * 
 */

#include <stddef.h>
#include <string.h>
#include <stdlib.h>
#include <tcl.h>
#include <netmgt/netmgt_db.h>

#include <handle_t.h>

extern void_pt bufferHandleTable;


void FreeBuffer ( snmdb_buffer *new) 
{
if ( new!= NULL ) { ckfree (new); }
return;
}

snmdb_buffer *getNewBuffer ( void ) 
{
snmdb_buffer *new=NULL;
new=(snmdb_buffer *) malloc( sizeof (snmdb_buffer));
return(new); 
}

int tclsnmdb_init_buffer(
	void_pt clientData,
	Tcl_Interp *interp,
	int argc, 
	char **argv)
{
char *name=NULL;
char *type=NULL;
char *buffer=NULL;

snmdb_buffer *newBf=NULL;
void_pt *hdl=NULL;


	/* get args */
	name=argv[1];
	type=argv[2];
	buffer=argv[3];

	/* alocate new buffer */
	newBf=getNewBuffer();
	if ( buffer == NULL ) return TCL_ERROR;

	if ( !snmdb_init_buffer(name, type, newBf) ) { return TCL_ERROR; }

	/* Get the handle, and the buffer pointer. */
	hdl =(void_pt)Tcl_HandleAllocName(bufferHandleTable,interp->result,buffer);
	if ( hdl==NULL) return TCL_ERROR;
	*hdl=(void_pt)newBf;

/* ???? */
	return TCL_OK;

}

int tclsnmdb_free_buffer(
	void_pt clientData,
	Tcl_Interp *interp,
	int argc, 
	char **argv)
{
int i;
char *buffer=NULL;

snmdb_buffer *Bf=NULL;
void_pt *hdl=NULL;

	for (i=1; i<argc; i++) {
	/* get args */
	buffer=argv[i];

	/* Get the handle, and the buffer pointer. */
		hdl =Tcl_HandleXlate( interp, bufferHandleTable, argv[i] );
		if (hdl==(void_pt)NULL || *hdl==NULL) return TCL_ERROR;
    		Bf = (snmdb_buffer*) (*hdl);

	/* Release the handle, destroy the buffer */
    		Tcl_HandleFree( bufferHandleTable, hdl );
		FreeBuffer( Bf);

	}
	return TCL_OK;
}
