/* Copyright 1994 Sun Microsystems, Inc. All Rights Reserved. */
/**************************************************************************
 *	File:	db_del.c
 *
 * Corresponds to chapter 8.7: Deleting an Element Instance from 
 * the data base
 *
 **************************************************************************/

#include <sys/types.h>
#include <rpc/types.h>
#include <stdio.h>
#include <netmgt/netmgt_db.h>

main()
{

/* The following code segment shows how to delete the element "andrew"
 * from the database
 */

	/* Open the database */
	if (!snmdb_open()) {
		printf("snmdb_open() failed, error = %d\n", snm_error);
		exit(1);
	}

	snmdb_lock(TRUE,FALSE);

	if (!snmdb_delete("andrew")) {
		if (snm_error == SNMDB_SUBVIEW_IS_NOT_EMPTY)
			printf("Error: element's subview is not empty \n");
		else
			printf("Error: unable to delete element, error = %d\n",
				snm_error);
		snmdb_unlock();
		exit(1);
	}

	snmdb_unlock();
	printf("Deleted element 'andrew' \n");
}

